/* Хå  */
#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<wait.h>
#include	<signal.h>
#include	<Xm/Xm.h>
#include	<Xm/List.h>
#include	<Xm/Text.h>
#include	<Xm/TextF.h>
#include	<Xm/ToggleB.h>
#include	<Xm/Scale.h>
#include	<Xm/MessageB.h>

#include "main.h"
#include "dialogs.h"

#define	EXECFILE "mpeg_encode"

XtSignalId Signal_id ;
Widget Working_dialog ;
pid_t Pid ;
int Breakbyuser=0 ;
static int Fd=-1 ;
static char Tempname[32] ;

void Handler()
{
    XtNoticeSignal(Signal_id) ;
}

void SignalCB( XtPointer cd, XtSignalId *id )
{
    int status ;
    XtDestroyWidget( Working_dialog ) ;
    while(wait(&status)!=Pid) ;
    if( status && Breakbyuser==0 ) ErrorDialog(App_sh) ;
    Breakbyuser=0 ;
    if( Fd != -1 ){
	close(Fd) ;
	Fd=-1 ;
	remove(Tempname) ;
    }
}

void SetSignal( int signum )
{
    struct sigaction sa ;
    sigset_t sm ;

    sigemptyset( &sm ) ;
    sigaddset( &sm, SIGCLD ) ;
    /* Ͽ */
    sa.sa_handler = &Handler ;
    sa.sa_mask = sm ;
    /* ƥॳϺƥȤ褦ˤ */
    sa.sa_flags = SA_RESTART ;
    sigaction( signum, &sa, NULL ) ;

    Signal_id=XtAppAddSignal(app_con,SignalCB,NULL) ;
}

/* 󥻥ܥ󤬲줿 */
void CancelCB( Widget w, XtPointer cl, XtPointer cd )
{
    Breakbyuser=1 ;
    kill(Pid,SIGTERM) ;
}

void GenerateCB( Widget w, XtPointer cl, XtPointer cd )
{
    FILE *fp ;
    char *buf ;
    int i ;
    char *execargv[3] ;

    if( Fd != -1 ){
	close(Fd) ;
	Fd=-1 ;
	remove(Tempname) ;
    }
    strcpy(Tempname,"/tmp/XmPeGeNcOdE_XXXXXX") ;
    Fd=mkstemp(Tempname) ;
    if( Fd == -1 ){
        fprintf(stderr,"ƥݥ̾ޤ\n") ;
        exit(1) ;
    }
    fp=fdopen(Fd,"w") ;
    if( fp==NULL ){
        fprintf(stderr,"ƥݥե뤬Ǥޤ\n") ;
        exit(1) ;
    }
    /* Pattern */
    buf=XmTextFieldGetString(Patterntext) ;
    fprintf(fp,"PATTERN %s\n",buf) ;
    XtFree(buf) ;
    /* Output file */
    buf=XmTextFieldGetString(Outputtext) ;
    fprintf(fp,"OUTPUT %s\n",buf) ;
    XtFree(buf) ;
    /* Base file format */
    for( i=0 ; Basefileformat_buttons[i]!=NULL ; i++ ){
	if( XmToggleButtonGetState(Basefileformat_toggle[i])==True ){
	    fprintf(fp,"BASE_FILE_FORMAT %s\n",Basefileformat_buttons[i]) ;
	}
    }
    /* Input convert file */
    buf=XmTextFieldGetString(Inputconverttext) ;
    fprintf(fp,"INPUT_CONVERT %s\n",buf) ;
    XtFree(buf) ;
    /* Gop size */
    buf=XmTextFieldGetString(Gopsizetext) ;
    fprintf(fp,"GOP_SIZE %s\n",buf) ;
    XtFree(buf) ;
    /* SLICES_PER_FRAME */
    buf=XmTextFieldGetString(Slicesperframetext) ;
    fprintf(fp,"SLICES_PER_FRAME %s\n",buf) ;
    XtFree(buf) ;
     /* եꥹ */
    fprintf(fp,"INPUT_DIR .\nINPUT\n") ;
    for( i=0 ; i<Listnum ; i++ ){
	if( XmStringGetLtoR(Liststr[i],XmFONTLIST_DEFAULT_TAG,&buf)
	    ==True ){
	    fprintf(fp,"%s\n",buf);
	    XtFree(buf) ;
	}
    }
    fprintf(fp,"END_INPUT\n") ;
    /* Pixel */
    for( i=0 ; Pixel_buttons[i]!=NULL ; i++ ){
	if( XmToggleButtonGetState(Pixel_toggle[i])==True ){
	    fprintf(fp,"PIXEL %s\n",Pixel_buttons[i]) ;
	}
    }
    /* SLICES_PER_FRAME */
    buf=XmTextFieldGetString(Rangetext) ;
    fprintf(fp,"RANGE %s\n",buf) ;
    XtFree(buf) ;
    /* PSEARCH_ALG */
    for( i=0 ; Psearchalg_buttons[i]!=NULL ; i++ ){
	if( XmToggleButtonGetState(Psearchalg_toggle[i])==True ){
	    fprintf(fp,"PSEARCH_ALG %s\n",Psearchalg_buttons[i]) ;
	}
    }
    /* BSEARCH_ALG */
    for( i=0 ; Bsearchalg_buttons[i]!=NULL ; i++ ){
	if( XmToggleButtonGetState(Bsearchalg_toggle[i])==True ){
	    fprintf(fp,"BSEARCH_ALG %s\n",Bsearchalg_buttons[i]) ;
	}
    }
    XmScaleGetValue(Iqscalescale,&i) ;
    fprintf(fp,"IQSCALE %d\n",i) ;
    XmScaleGetValue(Pqscalescale,&i) ;
    fprintf(fp,"PQSCALE %d\n",i) ;
    XmScaleGetValue(Bqscalescale,&i) ;
    fprintf(fp,"BQSCALE %d\n",i) ;
    /* REFERENCE_FRAME */
    for( i=0 ; Referenceframe_buttons[i]!=NULL ; i++ ){
	if( XmToggleButtonGetState(Referenceframe_toggle[i])==True ){
	    fprintf(fp,"REFERENCE_FRAME %s\n",Referenceframe_buttons[i]) ;
	}
    }
    /* BUFFER_SIZE */
    buf=XmTextFieldGetString(Buffersizetext) ;
    fprintf(fp,"BUFFER_SIZE %s\n",buf) ;
    XtFree(buf) ;
    /* FRAME_RATE */
    for( i=0 ; Framerate_buttons[i]!=NULL ; i++ ){
	if( XmToggleButtonGetState(Framerate_toggle[i])==True ){
	    fprintf(fp,"FRAME_RATE %s\n",Framerate_buttons[i]) ;
	}
    }
    /* Other options */
    buf=XmTextGetString(Otheroptionstext) ;
    fprintf(fp,"%s\n",buf) ;
    XtFree(buf) ;

    fflush(fp) ;
    fclose(fp) ;

    execargv[0]=EXECFILE ;
    execargv[1]=Tempname ;
    execargv[2]=NULL ;

    if( ( Pid = fork() ) < 0 ){
	fprintf(stderr,"Can't fork()!\n") ;
	exit(-1) ;
    }
    if( Pid == 0 ){
        /* child process */
        execvp( *execargv, execargv ) ;
        _exit(1) ;
    }
    Working_dialog=WorkingDialog(App_sh) ;
    return ;
}

void ListDeselectCB( Widget w, XtPointer cl, XtPointer cd )
{
    XmListCallbackStruct *cb ;
    cb=(XmListCallbackStruct *)cd ;
    XmListDeselectItem(w,cb->item) ;
    return ;
}

void QuitCB( Widget w, XtPointer cl, XtPointer cd )
{
    exit(0); 
}
void NullCB( Widget w, XtPointer cl, XtPointer cd )
{
    return ;
}
