#include	<stdio.h>
#include	<signal.h>
#include	<Xm/Xm.h>
#include        <Xm/MainW.h>
#include	<Xm/Command.h>
#include        <Xm/RowColumn.h>
#include        <Xm/PushB.h>
#include        <Xm/CascadeB.h>
#include	<Xm/Frame.h>
#include	<Xm/Form.h>
#include	<Xm/Label.h>
#include	<Xm/ToggleB.h>
#include	<Xm/Scale.h>
#include	<Xm/Text.h>
#include	<Xm/TextF.h>
#include        <Xm/ScrolledW.h>
#include        <Xm/List.h>
#include	<Xm/MessageB.h>

#include "callbacks.h"
#include "dialogs.h"

String  fallback_resources[] = {
    "*fontList:     -adobe-helvetica-medium-r-*--12-*-*-*-*-*-*-*",
    "*XmText*fontList:     -misc-fixed-medium-r-*--14-*-*-*-*-*-*-*",
    "*XmTextField*fontList:     -misc-fixed-medium-r-*--14-*-*-*-*-*-*-*",
    "*XmList*fontList:     -misc-fixed-medium-r-*--14-*-*-*-*-*-*-*",
    "*background:   #c0c0c0",
    "*XmText*background:   #efe7d9",
    "*XmTextField*background:   #e9e7ef",
    "*XmList*background:   #d0d0e0",
    "*outputtext*background:   #f7ffe9",
    "*menu_bar.marginHeight: 0",
    "*menu_bar.marginWidth: 0",
    "*traversalOn: True",
    "*highlightThickness: 0",
    "*keyboardFocusPolicy: explicit",
    "*outputtext.columns: 40",
    "*gopsizetext.columns: 14",
    "*slicesperframetext.columns: 14",
    "*otheroptionstext.rows: 4",
    "*scrollBarDisplayPolicy: STATIC",
    /* label etc... */
    "*frameratebox.23_976.labelString: 23.976",
    "*frameratebox.29_97.labelString: 29.97",
    "*frameratebox.59_94.labelString: 59.94",
    "*iqscalescale*titleString: I-frames",
    "*pqscalescale*titleString: P-frames",
    "*bqscalescale*titleString: B-frames",
    "*button_generate.labelString: Generate",
    "*button_quit.labelString: Exit",
    "*errordialog.messageString: Error occured.",
    "*errordialog.dialogTitle: Error",
    "*workingdialog.messageString: Generating... ",
    "*workingdialog.dialogTitle: Working",
    "*informationdialog.messageString: Plese specify input files.",
    "*informationdialog.dialogTitle: Information",
    /* Default setting */
    "*outputtext.value: movie.mpg",
    "*patterntext.value: IBP",
    "*basefileformatbox.PNM.set: TRUE",
    "*inputconverttext.value: giftopnm *",
    "*pixelbox.HALF.set: TRUE",
    "*gopsizetext.value: 16",
    "*slicesperframetext.value: 1",
    "*rangetext.value: 0",
    "*psearchalgbox.SUBSAMPLE.set: TRUE",
    "*bsearchalgbox.CROSS2.set: TRUE",
    "*referenceframebox.ORIGINAL.set: TRUE",
    "*iqscalescale.value: 2",
    "*pqscalescale.value: 4",
    "*bqscalescale.value: 8",
    "*buffersizetext.value: 3276800",
    "*frameratebox.24.set: TRUE",
    NULL
} ;

char *Framerate_buttons[]={ "23_976","24","25","29_97",
			    "30","50","59_94","60", NULL } ;
char *Basefileformat_buttons[]={ "YUV","PPM","PNM","JPEG",
			    "JMOVIE",NULL } ;
char *Pixel_buttons[]={ "FULL","HALF",NULL } ;
char *Psearchalg_buttons[]={ "EXHAUSTIVE","TWOLEVEL",
			     "SUBSAMPLE", "LOGARITHMIC",NULL } ;
char *Bsearchalg_buttons[]={ "SIMPLE", "CROSS2", "EXHAUSTIVE",NULL } ;
char *Referenceframe_buttons[]= { "ORIGINAL", "DECODED",NULL } ;

XtAppContext app_con ;
Widget App_sh ;
Widget Frameratebox, Basefileformatbox, Pixelbox ;
Widget Psearchalgbox, Bsearchalgbox, Referenceframebox ;
Widget Outputtext, Patterntext, Inputconverttext ;
Widget Gopsizetext, Slicesperframetext, Rangetext ;
Widget Buffersizetext, Otheroptionstext ;
Widget Iqscalescale,Pqscalescale,Bqscalescale ;

Widget Framerate_toggle[XtNumber(Framerate_buttons)-1] ;
Widget Basefileformat_toggle[XtNumber(Basefileformat_buttons)-1] ;
Widget Pixel_toggle[XtNumber(Pixel_buttons)-1] ;
Widget Psearchalg_toggle[XtNumber(Psearchalg_buttons)-1] ;
Widget Bsearchalg_toggle[XtNumber(Bsearchalg_buttons)-1] ;
Widget Referenceframe_toggle[XtNumber(Referenceframe_buttons)-1] ;

int Listnum ;
XmString *Liststr ;

int main(int argc, char *argv[])
{
    Widget  main_win, button_generate, button_quit ;
    Widget  menu_bar, form ;
    Widget  qscale, qscaleframe, qscaleform ;
    Widget  button ;
    Widget  fmenu ;
    Widget  framerateframe, framerate ;
    Widget  pattern ;
    Widget  output ;
    Widget  basefileformatframe, basefileformat ;
    Widget  inputconvert ;
    Widget  gopsize ;
    Widget  slicesperframe ;
    Widget  pixelframe, pixel ;
    Widget  range ;
    Widget  psearchalgframe, psearchalg ;
    Widget  bsearchalgframe, bsearchalg ;
    Widget  referenceframeframe, referenceframe ;
    Widget  buffersize ;
    Widget  otheroptions, otheroptionsframe ;
    Widget  filelist , filelistlist, filelistframe ;

    Arg     al[32] ;
    /* XtTranslations command_trans_table ; */
    int i,j,ac=0 ;
    FILE *fp ;
 
    XtSetLanguageProc(NULL, NULL, NULL) ;
    App_sh = XtAppInitialize(&app_con,"XMpegEncode",NULL,0,
			     &argc,argv,fallback_resources,al,ac);

    SetSignal(SIGCLD) ;
    
    /*  */
    Liststr=(XmString *)XtMalloc(sizeof(XmString)*argc-1) ;
    for( i=1,j=0 ; i<argc ; i++ ){
	fp=fopen(argv[i],"rb") ;
	if( fp!=NULL ){
	    Liststr[j]=XmStringCreateLtoR(argv[i],XmFONTLIST_DEFAULT_TAG) ;
	    fclose(fp) ;
	    j++ ;
	}
    }
    Listnum=j ;

    XtManageChild(main_win=XmCreateMainWindow(App_sh,"main_window",NULL,0));

    /* ե */
    form = XmCreateForm(main_win,"form",NULL,0) ;
    XtManageChild(form) ;

    output=
	XtVaCreateManagedWidget("output file",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;


    Outputtext=
	XtVaCreateManagedWidget("outputtext",xmTextFieldWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, output,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    button_quit=
	XtVaCreateManagedWidget("button_quit",xmPushButtonWidgetClass,form,
				XmNmarginWidth,4,
				XmNmarginHeight,4,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_NONE,
				XmNtopAttachment, XmATTACH_NONE,
				XmNrightAttachment, XmATTACH_FORM,
				XmNbottomAttachment, XmATTACH_FORM,
				XmNbottomOffset, 10,
				XmNleftOffset, 4,
				XmNrightOffset, 8,
				NULL ) ;
    XtAddCallback(button_quit,XmNactivateCallback,QuitCB,NULL) ;

    filelistframe=
	XtVaCreateManagedWidget("filelistframe",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_NONE,
				XmNtopAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNbottomAttachment, XmATTACH_WIDGET,
				XmNbottomWidget, button_quit,
				XmNrightOffset, 4,
				XmNbottomOffset, 8,
				NULL ) ;

    filelistlist=XmCreateScrolledList(filelistframe,"filelistlist",NULL,0) ;
    XtManageChild(filelistlist) ;
    
    XtVaSetValues(filelistlist,
		  XmNitems,Liststr,
		  XmNitemCount, Listnum,
		  NULL) ;

    XtAddCallback(filelistlist,XmNbrowseSelectionCallback,
		  ListDeselectCB,NULL) ;

    filelist=
	XtVaCreateManagedWidget("list of input files",xmLabelWidgetClass,
				filelistframe,
				XmNchildType,XmFRAME_TITLE_CHILD,
				NULL ) ;

    pattern=
	XtVaCreateManagedWidget("pattern",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, Outputtext,
				XmNtopAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    Patterntext=
	XtVaCreateManagedWidget("patterntext",xmTextFieldWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, Outputtext,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, pattern,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, filelistframe,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;


    basefileformat=
	XtVaCreateManagedWidget("base file format",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, Patterntext,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;
    basefileformatframe=
	XtVaCreateManagedWidget("framerateframe",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, basefileformat,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    XtManageChild(Basefileformatbox=XmCreateRadioBox(basefileformatframe,"basefileformatbox",NULL,0));
    XtVaSetValues(Basefileformatbox, XmNorientation, XmHORIZONTAL, NULL ) ;

    for( i=0 ; Basefileformat_buttons[i]!=NULL ; i++ ){
	Basefileformat_toggle[i]=
	    XtCreateManagedWidget(Basefileformat_buttons[i],
				  xmToggleButtonWidgetClass,
				  Basefileformatbox,NULL,0) ;
    }

    inputconvert=
	XtVaCreateManagedWidget("input convert",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, basefileformatframe,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, Patterntext,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    Inputconverttext=
	XtVaCreateManagedWidget("inputconverttext",xmTextFieldWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, basefileformatframe,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, inputconvert,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, filelistframe,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    pixel=
	XtVaCreateManagedWidget("pixel",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, basefileformatframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    pixelframe=
	XtVaCreateManagedWidget("pixel",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, pixel,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    XtManageChild(Pixelbox=XmCreateRadioBox(pixelframe,"pixelbox",NULL,0));
    XtVaSetValues(Pixelbox, XmNorientation, XmHORIZONTAL, NULL ) ;

    for( i=0 ; Pixel_buttons[i]!=NULL ; i++ ){
	Pixel_toggle[i]=
	    XtCreateManagedWidget(Pixel_buttons[i],
				  xmToggleButtonWidgetClass,
				  Pixelbox,NULL,0) ;
    }

    gopsize=
	XtVaCreateManagedWidget("gop size",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, pixelframe,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, basefileformatframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    Gopsizetext=
	XtVaCreateManagedWidget("gopsizetext",xmTextFieldWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, pixelframe,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, gopsize,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;


    slicesperframe=
	XtVaCreateManagedWidget("slices per frame",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, Gopsizetext,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, basefileformatframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    Slicesperframetext=
	XtVaCreateManagedWidget("slicesperframetext",xmTextFieldWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, Gopsizetext,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, slicesperframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    range=
	XtVaCreateManagedWidget("range",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, Slicesperframetext,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, basefileformatframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    Rangetext=
	XtVaCreateManagedWidget("rangetext",xmTextFieldWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, Slicesperframetext,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, range,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, filelistframe,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;


    psearchalg=
	XtVaCreateManagedWidget("P search algorithm",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, pixelframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    psearchalgframe=
	XtVaCreateManagedWidget("psearchalgframe",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, psearchalg,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, filelistframe,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    XtManageChild(Psearchalgbox=XmCreateRadioBox(psearchalgframe,"psearchalgbox",NULL,0));
    XtVaSetValues(Psearchalgbox, XmNorientation, XmHORIZONTAL, NULL ) ;

    for( i=0 ; Psearchalg_buttons[i]!=NULL ; i++ ){
	Psearchalg_toggle[i]=
	    XtCreateManagedWidget(Psearchalg_buttons[i],
				  xmToggleButtonWidgetClass,
				  Psearchalgbox,NULL,0) ;
    }

    bsearchalg=
	XtVaCreateManagedWidget("B search algorithm",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, psearchalgframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    bsearchalgframe=
	XtVaCreateManagedWidget("bsearchalgframe",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, bsearchalg,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    XtManageChild(Bsearchalgbox=XmCreateRadioBox(bsearchalgframe,"bsearchalgbox",NULL,0));
    XtVaSetValues(Bsearchalgbox, XmNorientation, XmHORIZONTAL, NULL ) ;

    for( i=0 ; Bsearchalg_buttons[i]!=NULL ; i++ ){
	Bsearchalg_toggle[i]=
	    XtCreateManagedWidget(Bsearchalg_buttons[i],
				  xmToggleButtonWidgetClass,
				  Bsearchalgbox,NULL,0) ;
    }

    referenceframe=
	XtVaCreateManagedWidget("referenece frame",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, bsearchalgframe,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, psearchalgframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    referenceframeframe=
	XtVaCreateManagedWidget("referenceframeframe",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, bsearchalgframe,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, referenceframe,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, filelistframe,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    XtManageChild(Referenceframebox=XmCreateRadioBox(referenceframeframe,"referenceframebox",NULL,0));
    XtVaSetValues(Referenceframebox, XmNorientation, XmHORIZONTAL, NULL ) ;

    for( i=0 ; Referenceframe_buttons[i]!=NULL ; i++ ){
	Referenceframe_toggle[i]=
	    XtCreateManagedWidget(Referenceframe_buttons[i],
				  xmToggleButtonWidgetClass,
				  Referenceframebox,NULL,0) ;
    }

    qscale=
	XtVaCreateManagedWidget("qscale",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, bsearchalgframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    qscaleframe=
	XtVaCreateManagedWidget("qscaleframe",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, qscale,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;
    qscaleform = XmCreateForm(qscaleframe,"qscaleform",NULL,0) ;
    XtManageChild(qscaleform) ;

    Iqscalescale=
	XtVaCreateManagedWidget("iqscalescale",xmScaleWidgetClass,qscaleform,
				XmNorientation, XmHORIZONTAL,
				XmNshowValue, XmNEAR_SLIDER,
				XmNminimum, 1,
				XmNmaximum, 31,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				NULL ) ;
    Pqscalescale=
	XtVaCreateManagedWidget("pqscalescale",xmScaleWidgetClass,qscaleform,
				XmNorientation, XmHORIZONTAL,
				XmNshowValue, XmNEAR_SLIDER,
				XmNminimum, 1,
				XmNmaximum, 31,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, Iqscalescale,
				XmNtopAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				NULL ) ;
    Bqscalescale=
	XtVaCreateManagedWidget("bqscalescale",xmScaleWidgetClass,qscaleform,
				XmNorientation, XmHORIZONTAL,
				XmNshowValue, XmNEAR_SLIDER,
				XmNminimum, 1,
				XmNmaximum, 31,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, Pqscalescale,
				XmNtopAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				NULL ) ;

    buffersize=
	XtVaCreateManagedWidget("buffer size",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, qscaleframe,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, bsearchalgframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    Buffersizetext=
	XtVaCreateManagedWidget("buffersizetext",xmTextFieldWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_WIDGET,
				XmNleftWidget, qscaleframe,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, buffersize,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, filelistframe,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;




    framerate=
	XtVaCreateManagedWidget("frame rate",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, qscaleframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;
    framerateframe=
	XtVaCreateManagedWidget("framerateframe",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, framerate,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, filelistframe,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    XtManageChild(Frameratebox=XmCreateRadioBox(framerateframe,"frameratebox",NULL,0));
    XtVaSetValues(Frameratebox, XmNorientation, XmHORIZONTAL, NULL ) ;

    for( i=0 ; Framerate_buttons[i]!=NULL ; i++ ){
	Framerate_toggle[i]=
	    XtCreateManagedWidget(Framerate_buttons[i],
				  xmToggleButtonWidgetClass,
				  Frameratebox,NULL,0) ;
    }

    button_generate=
	XtVaCreateManagedWidget("button_generate",xmPushButtonWidgetClass,form,
				XmNshowAsDefault,1,
				XmNmarginWidth,4,
				XmNmarginHeight,4,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_NONE,
				XmNtopAttachment, XmATTACH_NONE,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, button_quit,
				XmNbottomAttachment, XmATTACH_FORM,
				XmNbottomOffset, 4,
				XmNleftOffset, 4,
				XmNrightOffset, 8,
				NULL ) ;
    XtAddCallback(button_generate,XmNactivateCallback,GenerateCB,NULL) ;

    otheroptions=
	XtVaCreateManagedWidget("other options",xmLabelWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, framerateframe,
				XmNrightAttachment, XmATTACH_NONE,
				XmNbottomAttachment, XmATTACH_NONE,
				XmNleftOffset, 8,
				NULL ) ;

    otheroptionsframe=
	XtVaCreateManagedWidget("otheroptionsframe",xmFrameWidgetClass,form,
				XmNalignment,XmALIGNMENT_BEGINNING,
				XmNleftAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, otheroptions,
				XmNrightAttachment, XmATTACH_WIDGET,
				XmNrightWidget, filelistframe,
				/* XmNbottomAttachment, XmATTACH_NONE, */
				XmNbottomAttachment, XmATTACH_WIDGET,
				XmNbottomWidget, button_quit,
				XmNbottomOffset, 8,
				XmNleftOffset, 4,
				XmNrightOffset, 4,
				NULL ) ;

    ac=0;
    XtSetArg(al[ac],XmNeditMode,XmMULTI_LINE_EDIT) ;
    ac++ ;

    XtManageChild(Otheroptionstext=XmCreateScrolledText(otheroptionsframe,"otheroptionstext",al,ac));

    /* ˥塼С */
    XtManageChild(menu_bar=XmCreateMenuBar(main_win,"menu_bar",NULL,0));

    /* ե˥塼 */
    fmenu = XmCreatePulldownMenu(menu_bar,"FileMenu",NULL,0);
    XtVaSetValues( fmenu, XmNorientation, XmVERTICAL, NULL ) ;
    /* Generate */
    XtManageChild(button=XmCreatePushButton(fmenu,"Generate",NULL,0));
    XtAddCallback(button,XmNactivateCallback,GenerateCB,NULL);
    /* Quit */
    XtManageChild(button=XmCreatePushButton(fmenu,"Exit",NULL,0));
    XtAddCallback(button,XmNactivateCallback,QuitCB,NULL);
    /* Ͽ  */
    ac=0 ;
    XtSetArg(al[ac],XmNsubMenuId,fmenu);
    ac++ ;
    XtManageChild(button=XmCreateCascadeButton(menu_bar,"File",al,ac));

    /* mainɥϿ */
    XmMainWindowSetAreas(main_win,menu_bar,NULL,NULL,NULL,form) ;

    XtRealizeWidget(App_sh);

    if( Listnum==0 ) InfoDialog(App_sh) ;

    XtAppMainLoop(app_con);
    return(0) ;
}


